#pragma once

#include <vector>
#include "interface_fwd.h"

struct Input {
	int N, M, P, C;
	Board board;
};

enum OperationType {
	ROW_SHIFT = 0,
	COL_SHIFT
};

struct Operation {
	Operation(OperationType _type, int _index, int _times);

	OperationType type;
	int index;
	int times;
};

struct Solution {
	std::vector<Operation> operations;
};
